<?php
/*
* Pixel Point Creative Sound Space Module
* License: GNU General Public License version 2 
* More: http://www.gnu.org/copyleft/gpl.html
* Copyright (c) Pixel Point Creative LLC.
* More info at http://www.pixelpointcreative.com
* Review our terms/license here: http://pixelpointcreative.com/terms.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );
if (! class_exists("modSoundSpace") ) { 
class modSoundSpace {
	var $params;
	
	function __construct($params){
		$this->params = $params;
	}
	function &getInstance($params){
			$instance = null;
			if( !$instance ){
				$instance = new modSoundSpace($params);
			}
		return $instance;
	}
	
	
	
	function parseDesc ($description) {
		$description = str_replace("<br />", "\n", $description);
		$description = explode("\n",$description);
		
		$descriptionArray = array();
		foreach($description as $desc){
			if ($desc) {
				$list = preg_split ('/::/', $desc);
				$list[1] = (count($list) > 1) ? preg_split ('/&/', $list[1])  : array();
				$temp = array();			
				for ($i = 0; $i < count($list[1]); ++$i) {
					$l = preg_split ('/=/', $list[1][$i]);
					$temp[trim($l[0])] = trim($l[1]);
				}
				$descriptionArray[$list[0]] = $temp;
			}
		}
		
		return $descriptionArray;
	}
	
	function getInfo($params){
		$items = array();
		$folder 			= 	$params->get( 'folder', 'media/music/' );
		
		$orderby 			= 	$params->get( 'orderby', 0);
		$sort 				= 	$params->get( 'sort', '1');	
		$descriptions 		= 	$params->get( 'description',"");
		
		
		
		$folder = $this->checkURL(trim($folder));
		if(!$folder){ 
			echo "This folder doesn't exsist. Please add the correct path in the module parameters to your folder."; 
		} else {
			
			$titleArray = array();
			$descArray = array();
			$urlArray = array();
			$coverArray = array();
			$targetArray = array();
			
			if($descriptions != ''){
				$descriptionArray = $this->parseDesc($descriptions);	
			}
			$images = $this->getFileInDir($folder, $orderby, $sort );
	
			if (count($images) > 0) {
				foreach($images as $k=>$img) {
					$img = trim($img);				
	
					$imageArray[] = "$folder"."$img";				
	
					$titleArray[] = (isset($descriptionArray[$img]) && isset($descriptionArray[$img]['title'])) ? str_replace("'", "\'", $descriptionArray[$img]['title']) :'';
	
					$urlArray[] = (isset($descriptionArray[$img]) && isset($descriptionArray[$img]['url'])) ? $descriptionArray[$img]['url'] :'';				
	
					$targetArray[] = (isset($descriptionArray[$img]) && isset($descriptionArray[$img]['target'])) ? $descriptionArray[$img]['target'] :'';	
					
					$descArray[] = (isset($descriptionArray[$img]) && isset($descriptionArray[$img]['desc'])) ? $descriptionArray[$img]['desc'] :'';
					$coverArray[] = (isset($descriptionArray[$img]) && isset($descriptionArray[$img]['cover'])) ? $descriptionArray[$img]['cover'] :'';			
	
				}
				$items['files'] = $imageArray;
				$items['titles'] = $titleArray;
				$items['urls'] = $urlArray;
	
				$items['targets'] = $targetArray;
				$items['descs'] = $descArray;
				$items['covers'] = $coverArray;
			}		
		
	  }
	 
	
		
	 	return $items;
	}
	
	
	function getFileInDir($folder, $orderby, $sort){
		$imagePath 	= JPATH_SITE ."/".$folder;
		$imgFiles 	= JFolder::files( $imagePath );
		$folderPath = $folder .'/';
		$imageFile = array();
		$i = 0;
		foreach ($imgFiles as $file){
			$i_f 	= $imagePath .'/'. $file;
			if ( preg_match( "/mp3|mp4/i", $file ) && is_file( $i_f ) ) {
				$imageFile[$i][0] = $file;
				$imageFile[$i][1] = filemtime($i_f)	;
				$i++;
			}
		}
		$images = $this->sortImage($imageFile, $orderby , $sort);
		return $images;
	}
	function sortImage($image, $orderby , $sort){
		$sortObj = array();
		$imageName = array();
		if($orderby == 1){
			for($i=0;$i<count($image);$i++){
				$sortObj[$i] = $image[$i][1];
				$imageName[$i] = $image[$i][0];
			}
		}
		else{
			for($i=0;$i<count($image);$i++){
				$sortObj[$i] = $image[$i][0];
			}
			$imageName = $sortObj;
		}
		
		if($sort == 1) array_multisort($sortObj, SORT_ASC, $imageName);
		elseif($sort == 2)	array_multisort($sortObj, SORT_DESC, $imageName);
		else shuffle($imageName);
		return $imageName;
	}
	function checkURL($url){
		if(is_dir($url)){ $url = (substr($url,-1,1) == "/") ? $url : $url."/";	return $url; }
		else { return false; }	
	}
	
 }	
}
?>
